// contains bool vector operations
// ****************************************************************
// ****************************************************************
#ifndef BIT_STRING_H
#define BIT_STRING_H 

#include<cmath>
#include<algo.h>
#include <vector.h>
#include<iostream.h>
#include<string>

using namespace std;

// ****************************************************************
// ****************************************************************

size_t B_to_I(const vector<bool>& b, const size_t start, const size_t len)
{ size_t zp = 1;
  size_t sum = 0;
  long int end = (long int) start + len - 1;
  long int begin = (long int) start;
  for( long int i=end; i >= begin; i--)
  { if( b[i] ) sum = sum + zp;
    zp = zp << 1;
  }
  return sum;
}

// ****************************************************************

ostream& operator<<(ostream& out, const vector<bool> bs)
{ size_t bs_size = bs.size();
//  string out_string(bs_size);
  string out_string;
  if (bs_size > 0) out_string = (bs[0] ? '1' : '0');
  for( size_t i=1; i < bs_size; i++) 
    out_string = out_string + (bs[i] ? '1' : '0');
  out << out_string;
  return out;
}

// ****************************************************************

#endif
